do env
on error
#include .\Include\Tools_base.h
=_time()
*--------------------------------------------------------------------------
procedure	_time()
	=	Prologue()
local	 x
___s	=	seconds()
	= 	do_it()

___s	=	seconds() - ___s


x = ttoc( { 00:00 } + ___s, 2)

acti screen
?'>>', x, ___s
endproc
*---------------------------------------------------------------------------
procedure	prologue()
	
	
endproc
*---------------------------------------------------------------------------
function do_it()

	local i,obj
	assert Collection_Object(@m.obj)
	
	for i = 1 to 10000
		assert m.obj.add(m.i, str(m.i))
	endfor
	
	
	
	 =m.obj.Reverse()
	
	
endfunc
*---------------------------------------------------------------------------
#if FALSE
function do_it()

	&& = Test_01()
	&&  = Test_02()
	 &&  = Test_03()
	&& = StressTest()
	=TestVue()
endfunc
*---------------------------------------------------------------------------
*---------------------------------------------------------------------------
#if FALSE

     A
     /  \
   B    D
 /      / \
C      E  G
        \
         F
#endif

function Test_01()

	local obj, QueueObj, CycleInfoString, s

	assert Dependency_Object(@m.obj)
	
	assert m.obj.Edge('A', 'B')
	assert m.obj.Edge('B', 'C')
	
	assert m.obj.Edge('A', 'D')
	assert m.obj.Edge('D', 'E')
	assert m.obj.Edge('D', 'G')
	
	assert m.obj.Edge('E', 'F')

	assert m.obj.Dependency(@m.QueueObj, @m.CycleInfoString)
	
	do while m.QueueObj.DeQueue(@m.s)
		?s
	enddo
	
	
endfunc
*---------------------------------------------------------------------------
#if FALSE
	* a = b + c
	 * c = d + e
	 * 
	 * should get b d e c a (or d e c b a)
	 */
#endif

function Test_02()

	local obj, QueueObj, CycleInfoString, s

	assert Dependency_Object(@m.obj)
	
	assert m.obj.Edge("a", "b")
	assert m.obj.Edge("a", "c")
	assert m.obj.Edge("c", "e")
	assert m.obj.Edge("c", "d")
	&& assert m.obj.Edge("e", "a")

	assert m.obj.Dependency(@m.QueueObj, @m.CycleInfoString)
	
	do while m.QueueObj.DeQueue(@m.s)
		?s
	enddo
	
	
endfunc
*---------------------------------------------------------------------------
function Test_03()

	local obj, QueueObj, CycleInfoString, s

	assert Dependency_Object(@m.obj)
	
	assert m.obj.Edge("a", "b")
	assert m.obj.Edge("a", "c")
	assert m.obj.Edge("c", "e")
	assert m.obj.Edge("c", "d")
	assert m.obj.Edge("e", "a")

	assert m.obj.Dependency(@m.QueueObj, @m.CycleInfoString)
	
	do while m.QueueObj.DeQueue(@m.s)
		?s
	enddo
	
	
endfunc
*---------------------------------------------------------------------------
#define NODE_MAX		1000
#define PREDECESSORS	10
function StressTest()

	local obj, QueueObj, CycleInfoString
	assert Dependency_Object(@m.obj)
	
	local i, j
	for i = 1 to NODE_MAX
		for j = 1 to PREDECESSORS
			assert m.obj.Edge(m.i, m.i + m.j)
		
		endfor
	endfor
	
	assert m.obj.Dependency(@m.QueueObj, @m.CycleInfoString)
	
	assert m.QueueObj.Count == NODE_MAX + PREDECESSORS
	
	&& ?QueueObj.show()
endfunc
*---------------------------------------------------------------------------
*-------------------------------------------------------------------------------
function TestVue()

	local Success
	Success = TRUE
	
	local obj, QueueObj, CycleInfoString, LaVue
	
	do case
	case !m.Success
	
	case !Dependency_Object(@m.obj)
		assert FALSE
		Success = FALSE
		
	case !m.obj.Edge('VueB', 'VueC')
		assert FALSE
		Success = FALSE
	
	case !m.obj.Edge('VueTop', 'VueA')
		assert FALSE
		Success = FALSE
	
	case !m.obj.Edge('VueTop', 'VueB')
		assert FALSE
		Success = FALSE
	
	case !m.obj.Dependency(@m.QueueObj, @m.CycleInfoString)
		assert FALSE
		Success = FALSE
	
	endcase
	
	do while m.Success and m.QueueObj.DeQueue(@m.LaVue)
		?m.LaVue  && =Requery(m.LaVue)
	
	enddo
	&&	VueC
	&&	VueA
	&&	VueB
	&&	VueTop
endfunc
*---------------------------------------------------------------------------
#endif && Dependency